diff --git a/gcc/tree-vect-data-refs.c b/gcc/tree-vect-data-refs.c
index 9aabcc1..ad924d8 100644
--- a/gcc/tree-vect-data-refs.c
+++ b/gcc/tree-vect-data-refs.c
@@ -72,8 +72,8 @@ vect_lanes_optab_supported_p (const char *name, convert_optab optab,
       limit_p = !targetm.array_mode_supported_p (mode, count);
       if (!int_mode_for_size (bits, limit_p).exists (&array_mode))
 	{
-	  if (dump_enabled_p ())
-	    dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+	  if (thing_enabled_p ())
+	    vect_location_writeln (OPT_RECORD_FAILURE,
 			     "no array mode for %s["
 			     HOST_WIDE_INT_PRINT_DEC "]\n",
 			     GET_MODE_NAME (mode), count);
@@ -83,15 +83,15 @@ vect_lanes_optab_supported_p (const char *name, convert_optab optab,
 
   if (convert_optab_handler (optab, array_mode, mode) == CODE_FOR_nothing)
     {
-      if (dump_enabled_p ())
-	dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+      if (thing_enabled_p ())
+	vect_location_writeln (OPT_RECORD_FAILURE,
                          "cannot use %s<%s><%s>\n", name,
                          GET_MODE_NAME (array_mode), GET_MODE_NAME (mode));
       return false;
     }
 
-  if (dump_enabled_p ())
-    dump_printf_loc (MSG_NOTE, vect_location,
+  if (thing_enabled_p ())
+    vect_location_writeln (OPT_RECORD_REMARK,
                      "can use %s<%s><%s>\n", name, GET_MODE_NAME (array_mode),
                      GET_MODE_NAME (mode));
 
@@ -181,9 +181,9 @@ vect_check_nonzero_value (loop_vec_info loop_vinfo, tree value)
     if (checks[i] == value)
       return;
 
-  if (dump_enabled_p ())
+  if (thing_enabled_p ())
     {
-      dump_printf_loc (MSG_NOTE, vect_location, "need run-time check that ");
+      vect_location_writeln (OPT_RECORD_REMARK, "need run-time check that ");
       dump_generic_expr (MSG_NOTE, TDF_SLIM, value);
       dump_printf (MSG_NOTE, " is nonzero\n");
     }
@@ -338,9 +338,9 @@ vect_analyze_data_ref_dependence (struct data_dependence_relation *ddr,
       if (STMT_VINFO_GATHER_SCATTER_P (stmtinfo_a)
 	  || STMT_VINFO_GATHER_SCATTER_P (stmtinfo_b))
 	{
-	  if (dump_enabled_p ())
+	  if (thing_enabled_p ())
 	    {
-	      dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+	      vect_location_writeln (OPT_RECORD_FAILURE,
 			       "versioning for alias not supported for: "
 			       "can't determine dependence between ");
 	      dump_generic_expr (MSG_MISSED_OPTIMIZATION, TDF_SLIM,
@@ -353,9 +353,9 @@ vect_analyze_data_ref_dependence (struct data_dependence_relation *ddr,
 	  return true;
 	}
 
-      if (dump_enabled_p ())
+      if (thing_enabled_p ())
 	{
-	  dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+	  vect_location_writeln (OPT_RECORD_FAILURE,
 			   "versioning for alias required: "
 			   "can't determine dependence between ");
 	  dump_generic_expr (MSG_MISSED_OPTIMIZATION, TDF_SLIM,
@@ -386,9 +386,9 @@ vect_analyze_data_ref_dependence (struct data_dependence_relation *ddr,
       if (STMT_VINFO_GATHER_SCATTER_P (stmtinfo_a)
 	  || STMT_VINFO_GATHER_SCATTER_P (stmtinfo_b))
 	{
-	  if (dump_enabled_p ())
+	  if (thing_enabled_p ())
 	    {
-	      dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+	      vect_location_writeln (OPT_RECORD_FAILURE,
 			       "versioning for alias not supported for: "
 			       "bad dist vector for ");
 	      dump_generic_expr (MSG_MISSED_OPTIMIZATION, TDF_SLIM,
@@ -401,9 +401,9 @@ vect_analyze_data_ref_dependence (struct data_dependence_relation *ddr,
 	  return true;
 	}
 
-      if (dump_enabled_p ())
+      if (thing_enabled_p ())
         {
-          dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+          vect_location_writeln (OPT_RECORD_FAILURE,
                            "versioning for alias required: "
                            "bad dist vector for ");
           dump_generic_expr (MSG_MISSED_OPTIMIZATION, TDF_SLIM, DR_REF (dra));
@@ -426,15 +426,15 @@ vect_analyze_data_ref_dependence (struct data_dependence_relation *ddr,
     {
       int dist = dist_v[loop_depth];
 
-      if (dump_enabled_p ())
-	dump_printf_loc (MSG_NOTE, vect_location,
+      if (thing_enabled_p ())
+	vect_location_writeln (OPT_RECORD_REMARK,
                          "dependence distance  = %d.\n", dist);
 
       if (dist == 0)
 	{
-	  if (dump_enabled_p ())
+	  if (thing_enabled_p ())
 	    {
-	      dump_printf_loc (MSG_NOTE, vect_location,
+	      vect_location_writeln (OPT_RECORD_REMARK,
 	                       "dependence distance == 0 between ");
 	      dump_generic_expr (MSG_NOTE, TDF_SLIM, DR_REF (dra));
 	      dump_printf (MSG_NOTE, " and ");
@@ -462,8 +462,8 @@ vect_analyze_data_ref_dependence (struct data_dependence_relation *ddr,
 	     where loads from the group interleave with the store.  */
 	  if (!vect_preserves_scalar_order_p (DR_STMT (dra), DR_STMT (drb)))
 	    {
-	      if (dump_enabled_p ())
-		dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+	      if (thing_enabled_p ())
+		vect_location_writeln (OPT_RECORD_FAILURE,
 				 "READ_WRITE dependence in interleaving.\n");
 	      return true;
 	    }
@@ -475,8 +475,8 @@ vect_analyze_data_ref_dependence (struct data_dependence_relation *ddr,
 		vect_check_nonzero_value (loop_vinfo, indicator);
 	      else if (integer_zerop (indicator))
 		{
-		  if (dump_enabled_p ())
-		    dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+		  if (thing_enabled_p ())
+		    vect_location_writeln (OPT_RECORD_FAILURE,
 				 "access also has a zero step\n");
 		  return true;
 		}
@@ -489,8 +489,8 @@ vect_analyze_data_ref_dependence (struct data_dependence_relation *ddr,
 	  /* If DDR_REVERSED_P the order of the data-refs in DDR was
 	     reversed (to make distance vector positive), and the actual
 	     distance is negative.  */
-	  if (dump_enabled_p ())
-	    dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+	  if (thing_enabled_p ())
+	    vect_location_writeln (OPT_RECORD_FAILURE,
 	                     "dependence distance negative.\n");
 	  /* Record a negative dependence distance to later limit the
 	     amount of stmt copying / unrolling we can perform.
@@ -508,8 +508,8 @@ vect_analyze_data_ref_dependence (struct data_dependence_relation *ddr,
 	  /* The dependence distance requires reduction of the maximal
 	     vectorization factor.  */
 	  *max_vf = abs (dist);
-	  if (dump_enabled_p ())
-	    dump_printf_loc (MSG_NOTE, vect_location,
+	  if (thing_enabled_p ())
+	    vect_location_writeln (OPT_RECORD_REMARK,
 	                     "adjusting maximal vectorization factor to %i\n",
 	                     *max_vf);
 	}
@@ -518,15 +518,15 @@ vect_analyze_data_ref_dependence (struct data_dependence_relation *ddr,
 	{
 	  /* Dependence distance does not create dependence, as far as
 	     vectorization is concerned, in this case.  */
-	  if (dump_enabled_p ())
-	    dump_printf_loc (MSG_NOTE, vect_location,
+	  if (thing_enabled_p ())
+	    vect_location_writeln (OPT_RECORD_REMARK,
 	                     "dependence distance >= VF.\n");
 	  continue;
 	}
 
-      if (dump_enabled_p ())
+      if (thing_enabled_p ())
 	{
-	  dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+	  vect_location_writeln (OPT_RECORD_FAILURE,
 	               "not vectorized, possible dependence "
 	               "between data-refs ");
 	  dump_generic_expr (MSG_NOTE, TDF_SLIM, DR_REF (dra));
@@ -554,8 +554,8 @@ vect_analyze_data_ref_dependences (loop_vec_info loop_vinfo,
   unsigned int i;
   struct data_dependence_relation *ddr;
 
-  if (dump_enabled_p ())
-    dump_printf_loc (MSG_NOTE, vect_location,
+  if (thing_enabled_p ())
+    vect_location_writeln (OPT_RECORD_REMARK,
                      "=== vect_analyze_data_ref_dependences ===\n");
 
   LOOP_VINFO_DDRS (loop_vinfo)
@@ -619,9 +619,9 @@ vect_slp_analyze_data_ref_dependence (struct data_dependence_relation *ddr)
   /* Unknown data dependence.  */
   if (DDR_ARE_DEPENDENT (ddr) == chrec_dont_know)
     {
-      if  (dump_enabled_p ())
+      if  (thing_enabled_p ())
 	{
-	  dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+	  vect_location_writeln (OPT_RECORD_FAILURE,
 			   "can't determine dependence between ");
 	  dump_generic_expr (MSG_MISSED_OPTIMIZATION, TDF_SLIM, DR_REF (dra));
 	  dump_printf (MSG_MISSED_OPTIMIZATION,  " and ");
@@ -629,9 +629,9 @@ vect_slp_analyze_data_ref_dependence (struct data_dependence_relation *ddr)
 	  dump_printf (MSG_MISSED_OPTIMIZATION,  "\n");
 	}
     }
-  else if (dump_enabled_p ())
+  else if (thing_enabled_p ())
     {
-      dump_printf_loc (MSG_NOTE, vect_location,
+      vect_location_writeln (OPT_RECORD_REMARK,
 		       "determined dependence between ");
       dump_generic_expr (MSG_NOTE, TDF_SLIM, DR_REF (dra));
       dump_printf (MSG_NOTE, " and ");
@@ -724,8 +724,8 @@ vect_slp_analyze_node_dependences (slp_instance instance, slp_tree node,
 bool
 vect_slp_analyze_instance_dependence (slp_instance instance)
 {
-  if (dump_enabled_p ())
-    dump_printf_loc (MSG_NOTE, vect_location,
+  if (thing_enabled_p ())
+    vect_location_writeln (OPT_RECORD_REMARK,
                      "=== vect_slp_analyze_instance_dependence ===\n");
 
   /* The stores of this instance are at the root of the SLP tree.  */
@@ -784,17 +784,17 @@ vect_record_base_alignment (vec_info *vinfo, gimple *stmt,
   if (!existed || entry->base_alignment < drb->base_alignment)
     {
       entry = drb;
-      if (dump_enabled_p ())
+      if (thing_enabled_p ())
 	{
-	  dump_printf_loc (MSG_NOTE, vect_location,
+	  vect_location_writeln (OPT_RECORD_REMARK,
 			   "recording new base alignment for ");
 	  dump_generic_expr (MSG_NOTE, TDF_SLIM, drb->base_address);
 	  dump_printf (MSG_NOTE, "\n");
-	  dump_printf_loc (MSG_NOTE, vect_location,
+	  vect_location_writeln (OPT_RECORD_REMARK,
 			   "  alignment:    %d\n", drb->base_alignment);
-	  dump_printf_loc (MSG_NOTE, vect_location,
+	  vect_location_writeln (OPT_RECORD_REMARK,
 			   "  misalignment: %d\n", drb->base_misalignment);
-	  dump_printf_loc (MSG_NOTE, vect_location,
+	  vect_location_writeln (OPT_RECORD_REMARK,
 			   "  based on:     ");
 	  dump_gimple_stmt (MSG_NOTE, TDF_SLIM, stmt, 0);
 	}
@@ -867,8 +867,8 @@ vect_compute_data_ref_alignment (struct data_reference *dr)
   tree ref = DR_REF (dr);
   tree vectype = STMT_VINFO_VECTYPE (stmt_info);
 
-  if (dump_enabled_p ())
-    dump_printf_loc (MSG_NOTE, vect_location,
+  if (thing_enabled_p ())
+    vect_location_writeln (OPT_RECORD_REMARK,
                      "vect_compute_data_ref_alignment:\n");
 
   if (loop_vinfo)
@@ -902,13 +902,13 @@ vect_compute_data_ref_alignment (struct data_reference *dr)
       step_preserves_misalignment_p
 	= (DR_STEP_ALIGNMENT (dr) % vector_alignment) == 0;
 
-      if (dump_enabled_p ())
+      if (thing_enabled_p ())
 	{
 	  if (step_preserves_misalignment_p)
-	    dump_printf_loc (MSG_NOTE, vect_location,
+	    vect_location_writeln (OPT_RECORD_REMARK,
 			     "inner step divides the vector alignment.\n");
 	  else
-	    dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+	    vect_location_writeln (OPT_RECORD_FAILURE,
 			     "inner step doesn't divide the vector"
 			     " alignment.\n");
 	}
@@ -924,8 +924,8 @@ vect_compute_data_ref_alignment (struct data_reference *dr)
       step_preserves_misalignment_p
 	= multiple_p (DR_STEP_ALIGNMENT (dr) * vf, vector_alignment);
 
-      if (!step_preserves_misalignment_p && dump_enabled_p ())
-	dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+      if (!step_preserves_misalignment_p && thing_enabled_p ())
+	vect_location_writeln (OPT_RECORD_FAILURE,
 			 "step doesn't divide the vector alignment.\n");
     }
 
@@ -947,9 +947,9 @@ vect_compute_data_ref_alignment (struct data_reference *dr)
 	 negative when computing the starting misalignment below.  */
       || TREE_CODE (drb->step) != INTEGER_CST)
     {
-      if (dump_enabled_p ())
+      if (thing_enabled_p ())
 	{
-	  dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+	  vect_location_writeln (OPT_RECORD_FAILURE,
 	                   "Unknown alignment for access: ");
 	  dump_generic_expr (MSG_MISSED_OPTIMIZATION, TDF_SLIM, ref);
 	  dump_printf (MSG_MISSED_OPTIMIZATION, "\n");
@@ -965,9 +965,9 @@ vect_compute_data_ref_alignment (struct data_reference *dr)
 	  || !vect_can_force_dr_alignment_p (base,
 					     vector_alignment * BITS_PER_UNIT))
 	{
-	  if (dump_enabled_p ())
+	  if (thing_enabled_p ())
 	    {
-	      dump_printf_loc (MSG_NOTE, vect_location,
+	      vect_location_writeln (OPT_RECORD_REMARK,
 	                       "can't force alignment of ref: ");
 	      dump_generic_expr (MSG_NOTE, TDF_SLIM, ref);
 	      dump_printf (MSG_NOTE, "\n");
@@ -978,9 +978,9 @@ vect_compute_data_ref_alignment (struct data_reference *dr)
       /* Force the alignment of the decl.
 	 NOTE: This is the only change to the code we make during
 	 the analysis phase, before deciding to vectorize the loop.  */
-      if (dump_enabled_p ())
+      if (thing_enabled_p ())
         {
-          dump_printf_loc (MSG_NOTE, vect_location, "force alignment of ");
+          vect_location_writeln (OPT_RECORD_REMARK, "force alignment of ");
           dump_generic_expr (MSG_NOTE, TDF_SLIM, ref);
           dump_printf (MSG_NOTE, "\n");
         }
@@ -1004,9 +1004,9 @@ vect_compute_data_ref_alignment (struct data_reference *dr)
   if (!known_misalignment (misalignment, vector_alignment,
 			   &const_misalignment))
     {
-      if (dump_enabled_p ())
+      if (thing_enabled_p ())
 	{
-	  dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+	  vect_location_writeln (OPT_RECORD_FAILURE,
 			   "Non-constant misalignment for access: ");
 	  dump_generic_expr (MSG_MISSED_OPTIMIZATION, TDF_SLIM, ref);
 	  dump_printf (MSG_MISSED_OPTIMIZATION, "\n");
@@ -1016,9 +1016,9 @@ vect_compute_data_ref_alignment (struct data_reference *dr)
 
   SET_DR_MISALIGNMENT (dr, const_misalignment);
 
-  if (dump_enabled_p ())
+  if (thing_enabled_p ())
     {
-      dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+      vect_location_writeln (OPT_RECORD_FAILURE,
                        "misalign = %d bytes of ref ", DR_MISALIGNMENT (dr));
       dump_generic_expr (MSG_MISSED_OPTIMIZATION, TDF_SLIM, ref);
       dump_printf (MSG_MISSED_OPTIMIZATION, "\n");
@@ -1085,8 +1085,8 @@ vect_update_misalignment_for_peel (struct data_reference *dr,
       return;
     }
 
-  if (dump_enabled_p ())
-    dump_printf_loc (MSG_NOTE, vect_location, "Setting misalignment " \
+  if (thing_enabled_p ())
+    vect_location_writeln (OPT_RECORD_REMARK, "Setting misalignment " \
 		     "to unknown (-1).\n");
   SET_DR_MISALIGNMENT (dr, DR_MISALIGNMENT_UNKNOWN);
 }
@@ -1103,13 +1103,13 @@ verify_data_ref_alignment (data_reference_p dr)
     = vect_supportable_dr_alignment (dr, false);
   if (!supportable_dr_alignment)
     {
-      if (dump_enabled_p ())
+      if (thing_enabled_p ())
 	{
 	  if (DR_IS_READ (dr))
-	    dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+	    vect_location_writeln (OPT_RECORD_FAILURE,
 			     "not vectorized: unsupported unaligned load.");
 	  else
-	    dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+	    vect_location_writeln (OPT_RECORD_FAILURE,
 			     "not vectorized: unsupported unaligned "
 			     "store.");
 
@@ -1120,8 +1120,8 @@ verify_data_ref_alignment (data_reference_p dr)
       return false;
     }
 
-  if (supportable_dr_alignment != dr_aligned && dump_enabled_p ())
-    dump_printf_loc (MSG_NOTE, vect_location,
+  if (supportable_dr_alignment != dr_aligned && thing_enabled_p ())
+    vect_location_writeln (OPT_RECORD_REMARK,
 		     "Vectorizing an unaligned access.\n");
 
   return true;
@@ -1216,17 +1216,17 @@ vector_alignment_reachable_p (struct data_reference *dr)
     {
       HOST_WIDE_INT elmsize =
 		int_cst_value (TYPE_SIZE_UNIT (TREE_TYPE (vectype)));
-      if (dump_enabled_p ())
+      if (thing_enabled_p ())
 	{
-	  dump_printf_loc (MSG_NOTE, vect_location,
+	  vect_location_writeln (OPT_RECORD_REMARK,
 	                   "data size =" HOST_WIDE_INT_PRINT_DEC, elmsize);
 	  dump_printf (MSG_NOTE,
 	               ". misalignment = %d.\n", DR_MISALIGNMENT (dr));
 	}
       if (DR_MISALIGNMENT (dr) % elmsize)
 	{
-	  if (dump_enabled_p ())
-	    dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+	  if (thing_enabled_p ())
+	    vect_location_writeln (OPT_RECORD_FAILURE,
 	                     "data size does not divide the misalignment.\n");
 	  return false;
 	}
@@ -1236,8 +1236,8 @@ vector_alignment_reachable_p (struct data_reference *dr)
     {
       tree type = TREE_TYPE (DR_REF (dr));
       bool is_packed = not_size_aligned (DR_REF (dr));
-      if (dump_enabled_p ())
-	dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+      if (thing_enabled_p ())
+	vect_location_writeln (OPT_RECORD_FAILURE,
 	                 "Unknown misalignment, %snaturally aligned\n",
 			 is_packed ? "not " : "");
       return targetm.vectorize.vector_alignment_reachable (type, is_packed);
@@ -1271,8 +1271,8 @@ vect_get_data_access_cost (struct data_reference *dr,
   else
     vect_get_store_cost (dr, ncopies, inside_cost, body_cost_vec);
 
-  if (dump_enabled_p ())
-    dump_printf_loc (MSG_NOTE, vect_location,
+  if (thing_enabled_p ())
+    vect_location_writeln (OPT_RECORD_REMARK,
                      "vect_get_data_access_cost: inside_cost = %d, "
                      "outside_cost = %d.\n", *inside_cost, *outside_cost);
 }
@@ -1662,8 +1662,8 @@ vect_enhance_data_refs_alignment (loop_vec_info loop_vinfo)
   unsigned int mis, same_align_drs_max = 0;
   hash_table<peel_info_hasher> peeling_htab (1);
 
-  if (dump_enabled_p ())
-    dump_printf_loc (MSG_NOTE, vect_location,
+  if (thing_enabled_p ())
+    vect_location_writeln (OPT_RECORD_REMARK,
                      "=== vect_enhance_data_refs_alignment ===\n");
 
   /* Reset data so we can safely be called multiple times.  */
@@ -1828,8 +1828,8 @@ vect_enhance_data_refs_alignment (loop_vec_info loop_vinfo)
         {
           if (!aligned_access_p (dr))
             {
-              if (dump_enabled_p ())
-                dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+              if (thing_enabled_p ())
+                vect_location_writeln (OPT_RECORD_FAILURE,
                                  "vector alignment may not be reachable\n");
               break;
             }
@@ -2022,8 +2022,8 @@ vect_enhance_data_refs_alignment (loop_vec_info loop_vinfo)
 	  if (STMT_VINFO_GROUPED_ACCESS (stmt_info))
 	    npeel /= GROUP_SIZE (stmt_info);
 
-          if (dump_enabled_p ())
-            dump_printf_loc (MSG_NOTE, vect_location,
+          if (thing_enabled_p ())
+            vect_location_writeln (OPT_RECORD_REMARK,
                              "Try peeling by %d\n", npeel);
         }
 
@@ -2057,8 +2057,8 @@ vect_enhance_data_refs_alignment (loop_vec_info loop_vinfo)
               if (max_peel > max_allowed_peel)
                 {
                   do_peeling = false;
-                  if (dump_enabled_p ())
-                    dump_printf_loc (MSG_NOTE, vect_location,
+                  if (thing_enabled_p ())
+                    vect_location_writeln (OPT_RECORD_REMARK,
                         "Disable peeling, max peels reached: %d\n", max_peel);
                 }
             }
@@ -2107,11 +2107,11 @@ vect_enhance_data_refs_alignment (loop_vec_info loop_vinfo)
             LOOP_VINFO_PEELING_FOR_ALIGNMENT (loop_vinfo)
 	      = DR_MISALIGNMENT (dr0);
 	  SET_DR_MISALIGNMENT (dr0, 0);
-	  if (dump_enabled_p ())
+	  if (thing_enabled_p ())
             {
-              dump_printf_loc (MSG_NOTE, vect_location,
+              vect_location_writeln (OPT_RECORD_REMARK,
                                "Alignment of access forced using peeling.\n");
-              dump_printf_loc (MSG_NOTE, vect_location,
+              vect_location_writeln (OPT_RECORD_REMARK,
                                "Peeling for alignment will be applied.\n");
             }
 
@@ -2232,13 +2232,13 @@ vect_enhance_data_refs_alignment (loop_vec_info loop_vinfo)
           stmt_vec_info stmt_info = vinfo_for_stmt (stmt);
           dr = STMT_VINFO_DATA_REF (stmt_info);
 	  SET_DR_MISALIGNMENT (dr, 0);
-	  if (dump_enabled_p ())
-            dump_printf_loc (MSG_NOTE, vect_location,
+	  if (thing_enabled_p ())
+            vect_location_writeln (OPT_RECORD_REMARK,
                              "Alignment of access forced using versioning.\n");
         }
 
-      if (dump_enabled_p ())
-        dump_printf_loc (MSG_NOTE, vect_location,
+      if (thing_enabled_p ())
+        vect_location_writeln (OPT_RECORD_REMARK,
                          "Versioning for alignment will be applied.\n");
 
       /* Peeling and versioning can't be done together at this time.  */
@@ -2300,9 +2300,9 @@ vect_find_same_alignment_drs (struct data_dependence_relation *ddr)
 
   STMT_VINFO_SAME_ALIGN_REFS (stmtinfo_a).safe_push (drb);
   STMT_VINFO_SAME_ALIGN_REFS (stmtinfo_b).safe_push (dra);
-  if (dump_enabled_p ())
+  if (thing_enabled_p ())
     {
-      dump_printf_loc (MSG_NOTE, vect_location,
+      vect_location_writeln (OPT_RECORD_REMARK,
 		       "accesses have the same alignment: ");
       dump_generic_expr (MSG_NOTE, TDF_SLIM, DR_REF (dra));
       dump_printf (MSG_NOTE,  " and ");
@@ -2320,8 +2320,8 @@ vect_find_same_alignment_drs (struct data_dependence_relation *ddr)
 bool
 vect_analyze_data_refs_alignment (loop_vec_info vinfo)
 {
-  if (dump_enabled_p ())
-    dump_printf_loc (MSG_NOTE, vect_location,
+  if (thing_enabled_p ())
+    vect_location_writeln (OPT_RECORD_REMARK,
                      "=== vect_analyze_data_refs_alignment ===\n");
 
   /* Mark groups of data references with same alignment using
@@ -2349,8 +2349,8 @@ vect_analyze_data_refs_alignment (loop_vec_info vinfo)
 	      && !STMT_VINFO_GROUPED_ACCESS (stmt_info))
 	    continue;
 
-	  if (dump_enabled_p ())
-	    dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+	  if (thing_enabled_p ())
+	    vect_location_writeln (OPT_RECORD_FAILURE,
 			     "not vectorized: can't calculate alignment "
 			     "for data ref.\n");
 
@@ -2383,8 +2383,8 @@ vect_slp_analyze_and_verify_node_alignment (slp_tree node)
 	  && ! vect_compute_data_ref_alignment (first_dr))
       || ! verify_data_ref_alignment (dr))
     {
-      if (dump_enabled_p ())
-	dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+      if (thing_enabled_p ())
+	vect_location_writeln (OPT_RECORD_FAILURE,
 			 "not vectorized: bad data alignment in basic "
 			 "block.\n");
       return false;
@@ -2401,8 +2401,8 @@ vect_slp_analyze_and_verify_node_alignment (slp_tree node)
 bool
 vect_slp_analyze_and_verify_instance_alignment (slp_instance instance)
 {
-  if (dump_enabled_p ())
-    dump_printf_loc (MSG_NOTE, vect_location,
+  if (thing_enabled_p ())
+    vect_location_writeln (OPT_RECORD_REMARK,
                      "=== vect_slp_analyze_and_verify_instance_alignment ===\n");
 
   slp_tree node;
@@ -2455,9 +2455,9 @@ vect_analyze_group_access_1 (struct data_reference *dr)
 	 simply not include that gap.  */
       if ((dr_step % type_size) != 0)
 	{
-	  if (dump_enabled_p ())
+	  if (thing_enabled_p ())
 	    {
-	      dump_printf_loc (MSG_NOTE, vect_location,
+	      vect_location_writeln (OPT_RECORD_REMARK,
 	                       "Step ");
 	      dump_generic_expr (MSG_NOTE, TDF_SLIM, step);
 	      dump_printf (MSG_NOTE,
@@ -2487,9 +2487,9 @@ vect_analyze_group_access_1 (struct data_reference *dr)
 	  GROUP_FIRST_ELEMENT (vinfo_for_stmt (stmt)) = stmt;
 	  GROUP_SIZE (vinfo_for_stmt (stmt)) = groupsize;
 	  GROUP_GAP (stmt_info) = groupsize - 1;
-	  if (dump_enabled_p ())
+	  if (thing_enabled_p ())
 	    {
-	      dump_printf_loc (MSG_NOTE, vect_location,
+	      vect_location_writeln (OPT_RECORD_REMARK,
 	                       "Detected single element interleaving ");
 	      dump_generic_expr (MSG_NOTE, TDF_SLIM, DR_REF (dr));
 	      dump_printf (MSG_NOTE, " step ");
@@ -2500,9 +2500,9 @@ vect_analyze_group_access_1 (struct data_reference *dr)
 	  return true;
 	}
 
-      if (dump_enabled_p ())
+      if (thing_enabled_p ())
         {
- 	  dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+ 	  vect_location_writeln (OPT_RECORD_FAILURE,
 	                   "not consecutive access ");
 	  dump_gimple_stmt (MSG_MISSED_OPTIMIZATION, TDF_SLIM, stmt, 0);
         }
@@ -2514,7 +2514,7 @@ vect_analyze_group_access_1 (struct data_reference *dr)
           return true;
         }
 
-      dump_printf_loc (MSG_NOTE, vect_location, "using strided accesses\n");
+      vect_location_writeln (OPT_RECORD_REMARK, "using strided accesses\n");
       STMT_VINFO_STRIDED_P (stmt_info) = true;
       return true;
     }
@@ -2542,14 +2542,14 @@ vect_analyze_group_access_1 (struct data_reference *dr)
             {
               if (DR_IS_WRITE (data_ref))
                 {
-                  if (dump_enabled_p ())
-                    dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+                  if (thing_enabled_p ())
+                    vect_location_writeln (OPT_RECORD_FAILURE,
                                      "Two store stmts share the same dr.\n");
                   return false;
                 }
 
-	      if (dump_enabled_p ())
-		dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+	      if (thing_enabled_p ())
+		vect_location_writeln (OPT_RECORD_FAILURE,
 				 "Two or more load stmts share the same dr.\n");
 
               /* For load use the same data-ref load.  */
@@ -2576,8 +2576,8 @@ vect_analyze_group_access_1 (struct data_reference *dr)
 	      slp_impossible = true;
 	      if (DR_IS_WRITE (data_ref))
 		{
-                  if (dump_enabled_p ())
-                    dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+                  if (thing_enabled_p ())
+                    vect_location_writeln (OPT_RECORD_FAILURE,
                                      "interleaved store with gaps\n");
 		  return false;
 		}
@@ -2604,8 +2604,8 @@ vect_analyze_group_access_1 (struct data_reference *dr)
          inefficient way we have to cap earlier.  See PR78699 for example.  */
       if (groupsize > 4096)
 	{
-	  if (dump_enabled_p ())
-	    dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+	  if (thing_enabled_p ())
+	    vect_location_writeln (OPT_RECORD_FAILURE,
 			     "group is too large\n");
 	  return false;
 	}
@@ -2615,8 +2615,8 @@ vect_analyze_group_access_1 (struct data_reference *dr)
       if (groupsize != count
 	  && !DR_IS_READ (dr))
         {
-	  if (dump_enabled_p ())
-	    dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+	  if (thing_enabled_p ())
+	    vect_location_writeln (OPT_RECORD_FAILURE,
 			     "interleaved store with gaps\n");
 	  return false;
 	}
@@ -2628,9 +2628,9 @@ vect_analyze_group_access_1 (struct data_reference *dr)
       GROUP_GAP (vinfo_for_stmt (stmt)) = groupsize - last_accessed_element;
 
       GROUP_SIZE (vinfo_for_stmt (stmt)) = groupsize;
-      if (dump_enabled_p ())
+      if (thing_enabled_p ())
 	{
-	  dump_printf_loc (MSG_NOTE, vect_location,
+	  vect_location_writeln (OPT_RECORD_REMARK,
 			   "Detected interleaving ");
 	  if (DR_IS_READ (dr))
 	    dump_printf (MSG_NOTE, "load ");
@@ -2640,7 +2640,7 @@ vect_analyze_group_access_1 (struct data_reference *dr)
 		       (unsigned)groupsize);
 	  dump_gimple_stmt (MSG_NOTE, TDF_SLIM, stmt, 0);
 	  if (GROUP_GAP (vinfo_for_stmt (stmt)) != 0)
-	    dump_printf_loc (MSG_NOTE, vect_location,
+	    vect_location_writeln (OPT_RECORD_REMARK,
 			     "There is a gap of %u elements after the group\n",
 			     GROUP_GAP (vinfo_for_stmt (stmt)));
 	}
@@ -2707,8 +2707,8 @@ vect_analyze_data_ref_access (struct data_reference *dr)
 
   if (loop_vinfo && !step)
     {
-      if (dump_enabled_p ())
-	dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+      if (thing_enabled_p ())
+	vect_location_writeln (OPT_RECORD_FAILURE,
 	                 "bad data-ref access in loop\n");
       return false;
     }
@@ -2724,8 +2724,8 @@ vect_analyze_data_ref_access (struct data_reference *dr)
 	 loop-carried dependencies between inner loop iterations.  */
       if (loop->safelen < 2)
 	{
-	  if (dump_enabled_p ())
-	    dump_printf_loc (MSG_NOTE, vect_location,
+	  if (thing_enabled_p ())
+	    vect_location_writeln (OPT_RECORD_REMARK,
 			     "zero step in inner loop of nest\n");
 	  return false;
 	}
@@ -2741,8 +2741,8 @@ vect_analyze_data_ref_access (struct data_reference *dr)
       step = STMT_VINFO_DR_STEP (stmt_info);
       if (integer_zerop (step))
 	{
-	  if (dump_enabled_p ())
-	    dump_printf_loc (MSG_NOTE, vect_location,
+	  if (thing_enabled_p ())
+	    vect_location_writeln (OPT_RECORD_REMARK,
 	                     "zero step in outer loop.\n");
 	  return DR_IS_READ (dr);
 	}
@@ -2764,8 +2764,8 @@ vect_analyze_data_ref_access (struct data_reference *dr)
 
   if (loop && nested_in_vect_loop_p (loop, stmt))
     {
-      if (dump_enabled_p ())
-	dump_printf_loc (MSG_NOTE, vect_location,
+      if (thing_enabled_p ())
+	vect_location_writeln (OPT_RECORD_REMARK,
 	                 "grouped access in outer loop.\n");
       return false;
     }
@@ -2906,8 +2906,8 @@ vect_analyze_data_ref_accesses (vec_info *vinfo)
   vec<data_reference_p> datarefs = vinfo->datarefs;
   struct data_reference *dr;
 
-  if (dump_enabled_p ())
-    dump_printf_loc (MSG_NOTE, vect_location,
+  if (thing_enabled_p ())
+    vect_location_writeln (OPT_RECORD_REMARK,
                      "=== vect_analyze_data_ref_accesses ===\n");
 
   if (datarefs.is_empty ())
@@ -3030,9 +3030,9 @@ vect_analyze_data_ref_accesses (vec_info *vinfo)
 		break;
 	    }
 
-	  if (dump_enabled_p ())
+	  if (thing_enabled_p ())
 	    {
-	      dump_printf_loc (MSG_NOTE, vect_location,
+	      vect_location_writeln (OPT_RECORD_REMARK,
 			       "Detected interleaving ");
 	      if (DR_IS_READ (dra))
 		dump_printf (MSG_NOTE, "load ");
@@ -3060,8 +3060,8 @@ vect_analyze_data_ref_accesses (vec_info *vinfo)
     if (STMT_VINFO_VECTORIZABLE (vinfo_for_stmt (DR_STMT (dr))) 
         && !vect_analyze_data_ref_access (dr))
       {
-	if (dump_enabled_p ())
-	  dump_printf_loc (MSG_MISSED_OPTIMIZATION, vect_location,
+	if (thing_enabled_p ())
+	  vect_location_writeln (OPT_RECORD_FAILURE,
 	                   "not vectorized: complicated access pattern.\n");
 
         if (is_a <bb_vec_info> (vinfo))
@@ -3213,9 +3213,9 @@ dependence_distance_ge_vf (data_dependence_relation *ddr,
 	return false;
     }
 
-  if (dump_enabled_p ())
+  if (thing_enabled_p ())
     {
-      dump_printf_loc (MSG_NOTE, vect_location,
+      vect_location_writeln (OPT_RECORD_REMARK,
 		       "dependence distance between ");
       dump_generic_expr (MSG_NOTE, TDF_SLIM, DR_REF (DDR_A (ddr)));
       dump_printf (MSG_NOTE,  " and ");
@@ -3255,9 +3255,9 @@ vect_check_lower_bound (loop_vec_info loop_vinfo, tree expr, bool unsigned_p,
 	  {
 	    lower_bounds[i].unsigned_p = unsigned_p;
 	    lower_bounds[i].min_value = min_value;
-	    if (dump_enabled_p ())
+	    if (thing_enabled_p ())
 	      {
-		dump_printf_loc (MSG_NOTE, vect_location,
+		vect_location_writeln (OPT_RECORD_REMARK,
 				 "updating run-time check to ");
 		dump_lower_bound (MSG_NOTE, lower_bounds[i]);
 		dump_printf (MSG_NOTE, "\n");
@@ -3267,9 +3267,9 @@ vect_check_lower_bound (loop_vec_info loop_vinfo, tree expr, bool unsigned_p,
       }
 
   vec_lower_bound lower_bound (expr, unsigned_p, min_value);
-  if (dump_enabled_p ())
+  if (thing_enabled_p ())
     {
-      dump_printf_loc (MSG_NOTE, vect_location, "need a run-time check that ");
+      vect_location_writeln (OPT_RECORD_REMARK, "need a run-time check that ");
       dump_lower_bound (MSG_NOTE, lower_bound);
       dump_printf (MSG_NOTE, "\n");
     }
